--PvAI@LiveROzAIGkX3-858
--2006/10/11
--

require "./AI/Const.lua"
require "./AI/Util.lua"
require "./AI/USER_AI/IO.lua"
require "./AI/USER_AI/Setting.lua"
require "./AI/USER_AI/Config.lua"
-----------------------------
-- state
-----------------------------
IDLE_ST					= 0
FOLLOW_ST					= 1
CHASE_ST					= 2
ATTACK_ST					= 3
MOVE_CMD_ST					= 4
ATTACK_OBJECT_CMD_ST			= 6
SKILL_OBJECT_CMD_ST			= 10
FOLLOW_CMD_ST				= 12
----------------------------

------------------------------------------
-- global variable
------------------------------------------
MyState				= IDLE_ST	--ҋ@
MyEnemy				= 0		-- G id
MyDestX				= 0		-- ړIn xW
MyDestY				= 0		-- ړIn yW
ResCmdList				= List.new()	-- \R}hXg
MyID					= 0		-- zNX id
MyOwner				= GetV(0,0)			--lid
------------------------------------------


------------- command process  ---------------------

function	OnMOVE_CMD (x,y)

	if HoldFlag == 1 then			--HoldԂȂ
		HoldFlag = 0
	elseif MyDestX==x and MyDestY==y then		--OɎw肵n_ƍw肵n_ƈvĂ邩
		if GetV(V_MOTION,MyOwner)==6 then	--lĂ邩
			if GetFriend(x,y) then		--FBo^ɐ
				Move3(MyOwner)		--l̈ʒuɈړ
				return			--HoldԂɂ͂ȂȂ
			end
		end
		HoldFlag = 1			--HoldԂɂ
	end

	MyState = MOVE_CMD_ST
	MyDestX = x
	MyDestY = y

	Move2(x,y)
end


function	OnATTACK_OBJECT_CMD (id)	--̂܂܁A΃vC[ł͎sȂ
	MyEnemy = id
	AttackFlag = 1
	MyState = CHASE_ST
end

function	OnSKILL_OBJECT_CMD (level,skill,id)		--̂܂ܤ΃vC[ł͎sȂ
	SkillObject (MyID,level,skill,id)
end

function	OnFOLLOW_CMD ()

	-- ҋ@߂́Aҋ@ԂƋxԂ݂ɓ]
	if MyState ~= FOLLOW_CMD_ST then
		Move3(MyOwner)
		MyState = FOLLOW_CMD_ST
		MyEnemy = 0 
		AttackFlag = 0
		HoldFlag = 0
	else
		MyState = IDLE_ST
		MyEnemy = 0
	end
end


function	ProcessCommand (msg)

	if	(msg[1] == MOVE_CMD) then
		OnMOVE_CMD (msg[2],msg[3])
	elseif	(msg[1] == ATTACK_OBJECT_CMD) then
		OnATTACK_OBJECT_CMD (msg[2])
	elseif	(msg[1] == SKILL_OBJECT_CMD) then
		OnSKILL_OBJECT_CMD (msg[2],msg[3],msg[4],msg[5])
	elseif	(msg[1] == FOLLOW_CMD) then
		OnFOLLOW_CMD ()
	end
end

-------------- state process  --------------------


function	OnIDLE_ST ()

	local cmd = List.popleft(ResCmdList)
	if (cmd ~= nil) then		
		ProcessCommand (cmd)	-- \R}h 
		return 
	end

	local object = GetMyEnemy ()
	if object ~= 0 then
		MyState = CHASE_ST
		MyEnemy = object
		return;
	end

	if HoldFlag == 0 then
		if GetDistance2(MyID,MyOwner) > FollowRange then
			if GetV(V_MOTION,MyOwner) ~= 6 then	--ĂȂ
				MyState = FOLLOW_ST
			end
		end
	end

end

function	OnFOLLOW_ST ()

	if GetDistance2(MyID,MyOwner) <= FollowRange then 
		MyState = IDLE_ST
	elseif GetV(V_MOTION,MyID) == MOTION_STAND then
		Move3(MyOwner)
	elseif GetV(V_MOTION,MyID) == MOTION_MOVE then
 		if LastFollowTime + FollowDelay < CurTime then	--ǔfBCo߂Ă
			Move3(MyOwner)
			LastFollowTime = CurTime
		else						--ǔfBC̊ԂɍG
			MyState = IDLE_ST
		end
	end

end

function	OnCHASE_ST ()

	local dis =   GetDistance2(MyOwner,MyEnemy)

	if IsDead(MyEnemy) or ( dis>=ChaseRange and HoldFlag == 0 ) then
		MyState = IDLE_ST
		MyEnemy = 0
		AttackFlag = 0
		return;
	end

	dis = GetDistance2(MyID,MyEnemy)

	if 1 >= dis then				--U˒ɑ肪
		MyState = ATTACK_ST
		return;
	end

	if HoldFlag == 0 then				--HoldԂłȂ
		Move3(MyEnemy)
	else						--HoldԂȂ
		local near_enemy=GetNearEnemy()		--łz߂G擾
		if near_enemy~=0 then
			Attack(MyID,near_enemy)		--U
		end
	end
end

function	OnATTACK_ST ()

	if IsDead(MyEnemy) then
		MyState = IDLE_ST
		MyEnemy=0
		AttackFlag = 0
		return
	end

	local dis =   GetDistance2(MyID,MyEnemy)

	if 1 < dis then				--肪ꂽ
		MyState = CHASE_ST
		Move3(MyEnemy)
		return
	end

	Attack (MyID,MyEnemy)
end

function	OnMOVE_CMD_ST ()
	local x,y = GetV (V_POSITION,MyID)
	local dis =  GetDistance(x,y,MyDestX,MyDestY)

	if dis <= 1 then		--W΍˂ĒOҋ@Ԃɖ߂
		MyState = IDLE_ST
	end
end


function OnFOLLOW_CMD_ST ()
	if GetDistance2(MyID,MyOwner) > FollowRange then
		Move3(MyOwner)
	end
end

function	GetMyEnemy ()
	local result = 0
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local dis
	local max_prior = 1

	for i,v in ipairs(actors) do
		if v ~= MyOwner and v ~= MyID then
			if IsMonster(v) == 1 then
				if not IsDead(v) then
					local prior = GetPriority(v)
					if prior >= max_prior then
						dis = GetDistance2(MyOwner,v)
						if dis <= TargetRange then
							enemys[index]	= v
							index		= index+1
							if prior > max_prior then
								max_prior = prior
							end
						end
					end
				end
			end
		end
	end

	local min_dis	= TargetRange

	for i,v in ipairs(enemys) do
		if GetPriority(v) == max_prior then
			dis	= GetDistance2(MyOwner,v)
			if dis <= min_dis then
				result = v
				min_dis	= dis
			end
		end
	end

	return result
end

function AI(myid)


	MyID = myid
	local msg	= GetMsg (myid)
	local rmsg	= GetResMsg (myid)

	if msg[1] == NONE_CMD then
		if rmsg[1] == MOVE_CMD then
			GetEnemy2(rmsg[2],rmsg[3])
		elseif rmsg[1] == ATTACK_OBJECT_CMD then
			OnATTACK_OBJECT_CMD (msg[2])
		end
	else
		List.clear (ResCmdList)
		ProcessCommand (msg)
	end

	CurTime = GetTick()

	-- ԏ 
 	if (MyState == IDLE_ST) then
		OnIDLE_ST ()
	end
	if (MyState == CHASE_ST) then
		OnCHASE_ST ()
	end
	if (MyState == ATTACK_ST) then
		OnATTACK_ST ()
		if MultiAttackFlag == 1 then
			Attack(MyID,MyEnemy)
		end
	end
	if (MyState == FOLLOW_ST) then
		OnFOLLOW_ST ()
	elseif (MyState == MOVE_CMD_ST) then
		OnMOVE_CMD_ST ()
	elseif (MyState == ATTACK_OBJECT_CMD_ST) then
		OnATTACK_OBJECT_CMD_ST ()
	elseif (MyState == SKILL_OBJECT_CMD_ST) then
		OnSKILL_OBJECT_CMD_ST ()
	elseif (MyState == FOLLOW_CMD_ST) then
		OnFOLLOW_CMD_ST ()
	end

	AutoCaprice()
	DelFriend()
end
